#ifndef GAME_OF_LIFE_LIB_H
#define GAME_OF_LIFE_LIB_H

#include <stddef.h>
#include "../tui/tui.h"
#include "./bool_matrix.h"

typedef struct GameState {
  size_t time_step;
  size_t speed;
  bool simulation_active;
  bool selection_active;
  Size2 selection_start;
  Size2 cursor_pos;
  Size2 field_size;
  BoolMatrix* m_cur;
  BoolMatrix* m_next;
} GameState;

bool* bool_matrix_at_wrap(BoolMatrix* m, int x, int y);

size_t count_alive_neighbors(BoolMatrix* m, int x, int y);

void simulate(BoolMatrix* m_cur, BoolMatrix* m_next);

void save_matrix(BoolMatrix* m, const char* file_path, Size2 begin, Size2 end);

BoolMatrix* load_matrix(const char* file_path);

void swap(BoolMatrix** m1, BoolMatrix** m2);

bool handle_input(GameState* gs, char c);

void update(GameState* gs);

void draw(GameState* gs);

#endif /* GAME_OF_LIFE_LIB_H */
